> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://contentful.com/developers/docs/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://contentful.com/developers/docs/_mcp/server.

# Create a tag

PUT https://api.contentful.com/spaces/{space_id}/environments/{environment_id}/tags/{tag_id}
Content-Type: application/vnd.contentful.management.v1+json

Creates or updates a tag; tag IDs are immutable after creation. Set visibility via `X-Contentful-Tag-Visibility` header (defaults to `private`).

Reference: https://contentful.com/developers/docs/references/content-management-api/tags/create-a-tag

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `space_id` (string, required) — ID of the space in the form of a string
- `environment_id` (string, required) — ID of the environment in form of a string
- `tag_id` (string, required) — ID of the tag in form of a string

### Headers

- `X-Contentful-Tag-Visibility` (string, optional) — The tag visibility can be set in the header with this header. The visibility value set in the header overrides that in the payload.
- `X-Contentful-Version` (string, optional) — Version of the tag to update

### Body (application/vnd.contentful.management.v1+json)

This endpoint expects a map from string to any.

- `map from string to any`

## Response

### 201

Created - Resource created successfully

- `map from string to any`

## Examples

**Request**

```json
{
  "name": "NY Campaign",
  "sys": {
    "id": "nyCampaign",
    "type": "Tag",
    "visibility": "public"
  }
}
```

**Response**

```json
{
  "name": "NY Campaign",
  "sys": {
    "createdAt": "2025-02-09T07:02:05.000Z",
    "createdBy": {
      "sys": {
        "id": "7BslKh9TdKGOK41VmLDjFZ",
        "linkType": "User",
        "type": "Link"
      }
    },
    "environment": {
      "sys": {
        "id": "staging",
        "linkType": "Environment",
        "type": "Link"
      }
    },
    "id": "nyCampaign",
    "space": {
      "sys": {
        "id": "yadj1kx9rmg0",
        "linkType": "Space",
        "type": "Link"
      }
    },
    "type": "Tag",
    "updatedAt": "2025-02-09T07:02:05.000Z",
    "updatedBy": {
      "sys": {
        "id": "4FLrUHftHW3v2BLi9fzfjU",
        "linkType": "User",
        "type": "Link"
      }
    },
    "version": 1,
    "visibility": "public"
  }
}
```

**SDK Code**

```android Android
// Create the Contentful client.
final CMAClient client =
    new CMAClient
        .Builder()
        .setAccessToken("<access_token>")
        .setSpaceId("<space_id>")
        .setEnvironmentId("<environment_id>")
        .build();

final CMATag tag = new CMATag();
    tag.setName(name);
    tag.setId(tagId);
    tag.setVisibility(visibility);

client
    .tags()
    .async()
    .create(
        tag,
        new CMACallback<CMATag>() {
          @Override protected void onSuccess(CMATag result) {
            new AlertDialog.Builder(context)
                .setTitle("Contentful")
                .setMessage("Successfully created a new tag." +
                    "\n\nResult: " + result)
                .show();
          }

          @Override protected void onFailure(RuntimeException exception) {
            // An error occurred! Inform the user.
            new AlertDialog.Builder(context)
                .setTitle("Contentful Error")
                .setMessage("Could not create a new tag." +
                    "\n\nReason: " + exception.toString())
                .show();

            super.onFailure(exception);
          }
        }
    );
```

```java Java
// Create the Contentful client.
final CMAClient client =
    new CMAClient
        .Builder()
        .setAccessToken("<access_token>")
        .setSpaceId("<space_id>")
        .setEnvironmentId("<environment_id>")
        .build();

// Create a new tag.
CMATag result = client.tags()
  .create(
    "configuredSpaceId",
    "configuredEnvironmentId",
    "nyCampaign",
    "NY Campaign",
    CMAVisibility.publicVisibility);
```

```kotlin Kotlin
// Create the Contentful client.
val client = CMAClient.Builder()
    .setAccessToken("<access_token>")
    .setSpaceId("<space_id>")
    .setEnvironmentId("<environment_id>")
    .build()

// Create a new tag.
val result = client.tags()
  .create(
    "configuredSpaceId",
    "configuredEnvironmentId",
    "nyCampaign",
    "NY Campaign",
    CMAVisibility.publicVisibility)
```

```swift Swift
We currently don't provide a CMA SDK for this platform.
```

```js-legacy JavaScript (legacy)
import { createClient } from 'contentful-management'

const client = createClient({
  accessToken: '<content_management_api_key>'
}, { type: 'legacy' })

client.getSpace('<space_id>')
.then((space) => space.getEnvironment('<environment_id>'))
.then((env) => env.createTag('nyCampaign', 'NY Campaign'))
.then((tag) => console.log(tag))
.catch(console.error)
```

```javascript JavaScript
import { createClient } from 'contentful-management'

// Client init
const client = contentful.createClient({
  accessToken: '<content_management_api_key>'
})

const tag = await client.tag.createWithId({
  spaceId: '<space_id>',
  environmentId: '<environment_id>',
  tagId: '<tag_id>'
}, {
  name: '<tag_name>',
  sys: {
    visibility: 'public',
  }
});
```

```php PHP
SDK currently doesn't implement this endpoint.
```

```ruby Ruby
require 'contentful/management'

client = Contentful::Management::Client.new('<content_management_api_key>')

# create a tag
tag = client.tags('<space_id>', '<environment_id>').create(id: 'nyCampaign', name: 'NY Campaign')
```

```python Python
from contentful_management import Client

client = Client('<content_management_api_key>')

new_tag = client.tags('<space_id>', '<environment_id>').create('new_tag_id', {'name': 'My Tag'})
```

```.net .NET
// This client should only be created once per application.
var httpClient = new HttpClient();

var client = new ContentfulManagementClient(httpClient, "<content_management_api_key>", "<space_id>");

var tag = await client.CreateContentTag(name:"<name>", id:"<id>", publiclyVisible: true);
```